package nl.xservices.plugins;
import android.Manifest;
import android.app.Activity;
import android.content.pm.PackageManager;
import android.support.v4.app.ActivityCompat;
import android.util.Log;
import android.widget.*;
import android.widget.Toast;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.security.Permission;

/**
* This class echoes a string called from JavaScript.
*/
public class ImageDownloader extends CordovaPlugin {

@Override
public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
    if (action.equals("download")) {
        String message = args.getString(0);

        this.downloadFromUrl(message,callbackContext);
        return true;
    }
    return false;
}

  // Storage Permissions
  private static final int REQUEST_EXTERNAL_STORAGE = 1;
  private static String[] PERMISSIONS_STORAGE = {
    Manifest.permission.READ_EXTERNAL_STORAGE,
    Manifest.permission.WRITE_EXTERNAL_STORAGE
  };

  /**
   * Checks if the app has permission to write to device storage
   *
   * If the app does not has permission then the user will be prompted to grant permissions
   *
   * @param activity
   */
  public static void verifyStoragePermissions(Activity activity) {
    // Check if we have write permission
    int permission = ActivityCompat.checkSelfPermission(activity, Manifest.permission.WRITE_EXTERNAL_STORAGE);

    if (permission != PackageManager.PERMISSION_GRANTED) {
      // We don't have permission so prompt the user
      ActivityCompat.requestPermissions(
        activity,
        PERMISSIONS_STORAGE,
        REQUEST_EXTERNAL_STORAGE
      );
    }
  }

  public Boolean downloadFromUrl(String imageURL, CallbackContext callbackContext) {  //this is the downloader method

     android.widget.Toast.makeText(cordova.getActivity().getWindow().getContext() ,"开始下载", Toast.LENGTH_LONG).show();

    try {
      verifyStoragePermissions(cordova.getActivity());
      int lastIndexOfSlash = imageURL.lastIndexOf("/");
      String fileName = imageURL.substring(lastIndexOfSlash+1);
      File root = android.os.Environment.getExternalStorageDirectory();
      File dir = new File(root.getAbsolutePath() + "/mnt/sdcard/images");
      if(dir.exists() == false){
        dir.mkdirs();
      }
      URL url = new URL(imageURL); //you can write here any link
       File file = new File(dir,fileName);
     // Boolean rlt =  file.createNewFile();

      long startTime = System.currentTimeMillis();
      URLConnection ucon = url.openConnection();
      InputStream is = ucon.getInputStream();
      BufferedInputStream bis = new BufferedInputStream(is);

      FileOutputStream fos = new FileOutputStream(file);


      int current = 0;
      while ((current = bis.read()) != -1) {
        fos.write(current);
      }

      fos.close();
      Log.d("ImageManager", "download ready in"
        + ((System.currentTimeMillis() - startTime) / 1000)
        + " sec");
      callbackContext.success(file.getPath());
      return true;
    } catch (IOException e) {
      Log.d("ImageManager", "Error: " + e);
      callbackContext.error("download fail for "+e.getMessage());
      return false;
    }

  }
 
}
